Subject: Re: [PATCH net 0/6] rtnetlink: a bunch of fixes for userspace notifications in changing dev properties

From: Stefano Brivio <[email-masked]>
Date: Tue, 24 Oct 2017 22:44:19 +0200

On Sun, 15 Oct 2017 18:13:40 +0800
Xin Long <[email-masked]> wrote:

> Whenever any property of a link, address, route, etc. changes by whatever way,
> kernel should notify the programs that listen for such events in userspace.
> 
> The patchet "rtnetlink: Cleanup user notifications for netdev events" tried to
> fix a redundant notifications issue, but it also introduced a side effect.
> 
> After that, user notifications could only be sent when changing dev properties
> via netlink api. As it removed some events process in rtnetlink_event where
> the notifications was sent to users.
> 
> It resulted in no notification generated when dev properties are changed via
> other ways, like ioctl, sysfs, etc. It may cause some user programs doesn't
> work as expected because of the missing notifications.
> 
> This patchset will fix it by bringing some of these netdev events back and
> also fix the old redundant notifications issue with a proper way.
> 
> Xin Long (6):
>   rtnetlink: bring NETDEV_CHANGEMTU event process back in
>     rtnetlink_event
>   rtnetlink: bring NETDEV_CHANGE_TX_QUEUE_LEN event process back in
>     rtnetlink_event
>   rtnetlink: bring NETDEV_POST_TYPE_CHANGE event process back in
>     rtnetlink_event
>   rtnetlink: bring NETDEV_CHANGEUPPER event process back in
>     rtnetlink_event
>   rtnetlink: check DO_SETLINK_NOTIFY correctly in do_setlink
>   rtnetlink: do not set notification for tx_queue_len in do_setlink

I guess this should be considered for -stable (back to 4.12), as it
fixes quite a few critical issues in notification behaviours userspace
might rely on.

-- 
Stefano